package com.xkrs.service.impl;

import com.xkrs.dao.QcInspectionDataSourceDao;
import com.xkrs.dao.QcInspectionItemDictDao;
import com.xkrs.encapsulation.PromptMessageEnum;
import com.xkrs.model.entity.QcInspectionDataSource;
import com.xkrs.model.entity.QcInspectionItemDict;
import com.xkrs.model.qo.QcInspectionDataSourceQo;
import com.xkrs.service.QcInspectionDataSourceService;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Locale;

import static com.xkrs.encapsulation.OutputEncapsulation.outputEncapsulationObject;

/**
 * @Author: XinYi Song
 * @Date: 2022/1/19 16:43
 */
@Service
public class QcInspectionDataSourceServiceImpl implements QcInspectionDataSourceService {

    @Resource
    private QcInspectionDataSourceDao inspectionDataSourceDao;

    @Resource
    private QcInspectionItemDictDao inspectionItemDictDao;

    /**
     * 添加测量数据
     *
     * @param inspectionDataSourceQo
     * @return
     */
    @Override
    public String insertDataSource(QcInspectionDataSourceQo inspectionDataSourceQo) {
        Locale locale = LocaleContextHolder.getLocale();
        String lotNo = inspectionDataSourceQo.getLotNo();
        String machineNo = inspectionDataSourceQo.getMachineNo();
        String materialNo = inspectionDataSourceQo.getMaterialNo();
        String modelNo = inspectionDataSourceQo.getModelNo();
        String partNo = inspectionDataSourceQo.getPartNo();
        String inspectionItemCode = inspectionDataSourceQo.getInspectionItemCode();
        String inspectValue = inspectionDataSourceQo.getInspectValue();
        QcInspectionItemDict byInspectionItemCode = inspectionItemDictDao.findByInspectionItemCode(inspectionDataSourceQo.getInspectionItemCode());
        if (byInspectionItemCode == null) {
            return outputEncapsulationObject(PromptMessageEnum.DATA_NONE, "不存在该字典类型！", locale);
        }
        QcInspectionDataSource qcInspectionDataSource = new QcInspectionDataSource();
        if (inspectionDataSourceQo.getId() > 0) {
            qcInspectionDataSource.setId(inspectionDataSourceQo.getId());
        }
        qcInspectionDataSource.setLotNo(lotNo);
        qcInspectionDataSource.setMachineNo(machineNo);
        qcInspectionDataSource.setMaterialNo(materialNo);
        qcInspectionDataSource.setModelNo(modelNo);
        qcInspectionDataSource.setPartNo(partNo);
        qcInspectionDataSource.setInspectionItemCode(inspectionItemCode);
        qcInspectionDataSource.setInspectValue(inspectValue);
        inspectionDataSourceDao.save(qcInspectionDataSource);
        return outputEncapsulationObject(PromptMessageEnum.SUCCESS, "添加成功！", locale);
    }
}
